const OPTION_USER_FORMAT="userformat";

function onLoadPageFormats() {
	parent.initPanel('chrome://wikipedia/content/wikipedia_preferences_formats.xul');
	loadFormats();
	updateActivationSettings();
}

function updateActivationSettings() {
	document.getElementById('wikipedia.signature.text').disabled = !document.getElementById('wikipedia.signature.user').selected;
}

function addFormatItem(label,text) {
	var item=document.createElement('treeitem');
	var row=document.createElement('treerow');
	var cell=document.createElement('treecell');
	cell.setAttribute("label",label);
	row.appendChild(cell);
	cell=document.createElement('treecell');
	cell.setAttribute("label",text);
	row.appendChild(cell);
	item.appendChild(row);
	document.getElementById('formats').appendChild(item);
}

function addFormat() {
	var ok = [false];
	var params = ["","<format>SELECTION</format>"];
	window.openDialog("chrome://wikipedia/content/wikipedia_format_properties.xul", "&wikipedia.format.dialogtitle;","chrome,modal,centerscreen,resizable",ok,params);
	if (ok[0]){
		var label=params[0];
		var text=params[1];
		addFormatItem(label,text);
	}
	storeFormats();
}

function editFormat() {
	var tree=document.getElementById('tree-formats');
	var item=tree.view.getItemAtIndex(tree.currentIndex);
	var label=item.firstChild.firstChild.getAttribute("label");
	var text=item.firstChild.firstChild.nextSibling.getAttribute("label");
	var ok = [false];
	var params = [label,text];
	window.openDialog("chrome://wikipedia/content/wikipedia_format_properties.xul", "&wikipedia.format.dialogtitle;","chrome,modal,centerscreen,resizable",ok,params);
	if (ok[0]){
		label=params[0];
		text=params[1];
		item.firstChild.firstChild.setAttribute("label",label);
		item.firstChild.firstChild.nextSibling.setAttribute("label",text);
	}
	storeFormats();
}

function deleteFormat() {
	var tree=document.getElementById('tree-formats');
	var item=tree.view.getItemAtIndex(tree.currentIndex);
	document.getElementById('formats').removeChild(item);
	enableDelete(false);
	storeFormats();
}

function enableDelete(e) {
	document.getElementById('format-edit').disabled=!e;
	document.getElementById('format-delete').disabled=!e;
}

function storeFormats() {
	var wbPrefs = getPreferences();
	var items=document.getElementById('formats').childNodes;
	for (var i=0;i<items.length;i++) {
		wbPrefs.setCharPref(OPTION_USER_FORMAT+"."+i+".label",items[i].firstChild.firstChild.getAttribute("label"));
		wbPrefs.setCharPref(OPTION_USER_FORMAT+"."+i+".text",items[i].firstChild.firstChild.nextSibling.getAttribute("label"));
	}
	wbPrefs.setIntPref(OPTION_USER_FORMAT+".count",items.length);
}

function loadFormats() {
	var wbPrefs = getPreferences();
	var count=wbPrefs.getIntPref(OPTION_USER_FORMAT+".count");
	for (var i=0;i<count;i++) {
		var label=wbPrefs.getCharPref(OPTION_USER_FORMAT+"."+i+".label");
		var text=wbPrefs.getCharPref(OPTION_USER_FORMAT+"."+i+".text");
		addFormatItem(label,text);
	}
}