const OPTION_USER_TEMPLATE="usertemplate";

function onLoadPageTemplates() {
	parent.initPanel('chrome://wikipedia/content/wikipedia_preferences_templates.xul');
	loadTemplates();	
}

function addTemplateItem(label,text) {
	var item=document.createElement('treeitem');
	var row=document.createElement('treerow');
	var cell=document.createElement('treecell');
	cell.setAttribute("label",label);
	row.appendChild(cell);
	cell=document.createElement('treecell');
	cell.setAttribute("label",text);
	row.appendChild(cell);
	item.appendChild(row);
	document.getElementById('templates').appendChild(item);
}

function addTemplate() {
	var ok = [false];
	var params = ["",""];
	window.openDialog("chrome://wikipedia/content/wikipedia_template_properties.xul", "&wikipedia.template.dialogtitle;","chrome,modal,centerscreen,resizable",ok,params);
	if (ok[0]){
		var label=params[0];
		var text=params[1];
		addTemplateItem(label,text);
	}
	storeTemplates();
}

function editTemplate() {
	var tree=document.getElementById('tree-templates');
	var item=tree.view.getItemAtIndex(tree.currentIndex);
	var label=item.firstChild.firstChild.getAttribute("label");
	var text=item.firstChild.firstChild.nextSibling.getAttribute("label");
	var ok = [false];
	var params = [label,text];
	window.openDialog("chrome://wikipedia/content/wikipedia_template_properties.xul", "&wikipedia.template.dialogtitle;","chrome,modal,centerscreen,resizable",ok,params);
	if (ok[0]){
		label=params[0];
		text=params[1];
		item.firstChild.firstChild.setAttribute("label",label);
		item.firstChild.firstChild.nextSibling.setAttribute("label",text);
	}
	storeTemplates();
}

function deleteTemplate() {
	var tree=document.getElementById('tree-templates');
	var item=tree.view.getItemAtIndex(tree.currentIndex);
	document.getElementById('templates').removeChild(item);
	enableDelete(false);
	storeTemplates();
}

function enableDelete(e) {
	document.getElementById('template-edit').disabled=!e;
	document.getElementById('template-delete').disabled=!e;
}

function storeTemplates() {
	var wbPrefs = getPreferences();
	var items=document.getElementById('templates').childNodes;
	for (var i=0;i<items.length;i++) {
		wbPrefs.setCharPref(OPTION_USER_TEMPLATE+"."+i+".label",items[i].firstChild.firstChild.getAttribute("label"));
		wbPrefs.setCharPref(OPTION_USER_TEMPLATE+"."+i+".text",items[i].firstChild.firstChild.nextSibling.getAttribute("label"));
	}
	wbPrefs.setIntPref(OPTION_USER_TEMPLATE+".count",items.length);
}

function loadTemplates() {
	var wbPrefs = getPreferences();
	var count=wbPrefs.getIntPref(OPTION_USER_TEMPLATE+".count");
	for (var i=0;i<count;i++) {
		var label=wbPrefs.getCharPref(OPTION_USER_TEMPLATE+"."+i+".label");
		var text=wbPrefs.getCharPref(OPTION_USER_TEMPLATE+"."+i+".text");
		addTemplateItem(label,text);
	}
}